/*
 * cf_stats.h
 *
 *  Created on: Jan 19, 2011
 *      Author: Stephanie Stroka
 */

#ifndef CF_STATS_H_
#define CF_STATS_H_


struct cf_stats {
	int id;
	int run;
	int us_to_sleep;
	long used_pages;
	long max_used_pages;
	long num_alloc;
	long num_free;
	long num_compaction;
	uint64_t bytes_allocated_netto;
	uint64_t bytes_allocated_brutto;
	long class_counter[SIZECLASSES];
	uint64_t lock_time[SIZECLASSES];
	uint64_t lock_max_time[SIZECLASSES];
	uint64_t num_lock_class[SIZECLASSES];
	uint64_t compaction_time[SIZECLASSES];
	uint64_t max_compaction_time[SIZECLASSES];
	uint64_t num_compact_class[SIZECLASSES];
	uint64_t free_time[SIZECLASSES];
	uint64_t free_max_time[SIZECLASSES];
	uint64_t num_free_class[SIZECLASSES];
	uint64_t malloc_time[SIZECLASSES];
	uint64_t malloc_max_time[SIZECLASSES];
	uint64_t num_malloc_class[SIZECLASSES];
	//struct rectree rectree;
} __attribute__((aligned(128)));

extern struct cf_stats *get_cf_stats();

#endif /* CF_STATS_H_ */
